require 'collision'

-- love.load() is called once when a LövePotion game is ran.
function love.load()
    math.randomseed(os.time())
    
    font = love.graphics.newFont()
    bottombg = love.graphics.newImage('bottom.png')
    
    player = {}
    player.y = 90
    player.x = 10
    player.points = 0
    player.gfx = love.graphics.newImage('player.png')
    player.direction = 1;
    
    enemy = {}
    enemy.y = 90
    enemy.x = 300
    enemy.points = 0
    enemy.gfx = love.graphics.newImage('ai.png')
    enemy.direction = 1;
    
    ball = {}
    ball.still = 1
    ball.velocityx = 0
    ball.velocityy = 0
    ball.speed = 20;
    ball.x = 160
    ball.y = 120
    ball.futurex = 0;
    ball.futurey = 0;
    ball.gfx = love.graphics.newImage('ball.png')
    ball.collition = "false";
end

-- love.draw() is called every frame. Any and all draw code goes here. (images, shapes, text etc.)
function love.draw()
    love.graphics.setScreen('bottom')
        love.graphics.draw(bottombg, 0, 0)
        love.graphics.draw(player.gfx, player.x, player.y)       
        love.graphics.draw(enemy.gfx, enemy.x, enemy.y)
        love.graphics.draw(ball.gfx, ball.x, ball.y)
    
    love.graphics.setScreen('top')
        love.graphics.setColor(255, 255, 255)
        love.graphics.setFont(font)
        love.graphics.print(player.points,30,5)
        love.graphics.print(enemy.points,315,5)
end

function love.update(dt)
    -- VELOCITY CHECK
    if CheckCollision(ball.x - ball.gfx:getWidth()/2, ball.y - ball.gfx:getHeight()/2, ball.gfx:getWidth(), ball.gfx:getHeight(), player.x, player.y, player.gfx:getWidth(), player.gfx:getHeight()) == true then
        ball.collition = "true";
        ball.velocityx = ball.velocityx * -1
    else
        ball.collition = "false";
    end
    if CheckCollision(ball.x - ball.gfx:getWidth()/2, ball.y - ball.gfx:getHeight()/2, ball.gfx:getWidth(), ball.gfx:getHeight(), enemy.x, enemy.y, enemy.gfx:getWidth(), enemy.gfx:getHeight()) == true then
        ball.collition = "true";
        ball.velocityx = ball.velocityx * -1
    else
        ball.collition = "false";
    end
    
    ball.x = ball.x + ball.velocityx * dt * ball.speed
    ball.y = ball.y + ball.velocityy * dt * ball.speed
    
 -- AI1 CONTROLS
    if player.direction == 1 then
        player.y = player.y - 3;
        
        if player.y < 0 then
            player.direction = 2;
        end
    else
        player.y = player.y + 3;
        
        if player.y > 170 then
            player.direction = 1;
        end
    end
    
    --BALL CONTROLS
    if love.keyboard.isDown("up") then
            ball.y = ball.y - 6;
    else
        if love.keyboard.isDown("down") then
            ball.y = ball.y + 6;
        end
    end
    -- AI2 CONTROLS
    if enemy.direction == 1 then
        enemy.y = enemy.y - 3;
        
        if enemy.y < 0 then
            enemy.direction = 2;
        end
    else
        enemy.y = enemy.y + 3;
        
        if enemy.y > 170 then
            enemy.direction = 1;
        end
    end
    
    -- BUMPING CHECKS
    if ball.y > 230 then
        ball.velocityy = ball.velocityy * -1
        ball.speed = ball.speed + 2;
    end
    if ball.y < 0 then
        ball.velocityy = ball.velocityy * -1
        ball.speed = ball.speed + 2;
    end
    
    -- OUT OF BOUNDS CHECK
    if ball.x < -15 or ball.x > 330 then
        if ball.x < -15 then
            enemy.points = enemy.points + 1;
        end
        if ball.x > 330 then
            player.points = player.points + 1;
        end
        
        ball.velocityx = 0
        ball.velocityy = 0
        ball.x = 160
        ball.y = 120
        ball.still = 1
        ball.speed = 10
    end
    
    -- START
    if ball.still == 1 and love.keyboard.isDown("a") then
        ball.still = 0
        
        -- Velocityx = Velocityy * 2
        if ball.velocityx < 2 and ball.velocityx > -2 then
            ball.velocityx = math.random(-10,10)
        end
        ball.velocityy = 8
    end
end


function love.keypressed(key)
    
	-- If the start button is pressed, we return to the Homebrew Launcher
	if key == 'start' then
		love.event.quit() 
	end
    if key == 'select' then
        ball.velocityx = 0
        ball.velocityy = 0
        ball.x = 160
        ball.y = 120
        ball.still = 1
        ball.speed = 20
    end

end